Index: doc/groups.dox
===================================================================
--- doc/groups.dox	(revision 2530)
+++ doc/groups.dox	(revision 2548)
@@ -319,6 +319,35 @@
 for find matchings in graphs and bipartite graphs.
 
-This group provides some algorithm objects and function
-to calculate matchings in graphs and bipartite graphs.
+This group provides some algorithm objects and function to calculate
+matchings in graphs and bipartite graphs. The general matching problem is
+finding a subset of the edges which does not shares common endpoints.
+ 
+There are several different algorithms for calculate matchings in
+graphs.  The matching problems in bipartite graphs are generally
+easier than in general graphs. The goal of the matching optimization
+can be the finding maximum cardinality, maximum weight or minimum cost
+matching. The search can be constrained to find perfect or
+maximum cardinality matching.
+
+Lemon contains the next algorithms:
+- \ref lemon::MaxBipartiteMatching "MaxBipartiteMatching" Hopcroft-Karp 
+  augmenting path algorithm for calculate maximum cardinality matching in 
+  bipartite graphs
+- \ref lemon::PrBipartiteMatching "PrBipartiteMatching" Push-Relabel 
+  algorithm for calculate maximum cardinality matching in bipartite graphs 
+- \ref lemon::MaxWeightedBipartiteMatching "MaxWeightedBipartiteMatching" 
+  Successive shortest path algorithm for calculate maximum weighted matching 
+  and maximum weighted bipartite matching in bipartite graph
+- \ref lemon::MinCostMaxBipartiteMatching "MinCostMaxBipartiteMatching" 
+  Successive shortest path algorithm for calculate minimum cost maximum 
+  matching in bipartite graph
+- \ref lemon::MaxMatching "MaxMatching" Edmond's blossom shrinking algorithm
+  for calculate maximum cardinality matching in general graph
+- \ref lemon::MaxWeightedMatching "MaxWeightedMatching" Edmond's blossom
+  shrinking algorithm for calculate maximum weighted matching in general
+  graph
+- \ref lemon::MaxWeightedPerfectMatching "MaxWeightedPerfectMatching"
+  Edmond's blossom shrinking algorithm for calculate maximum weighted
+  perfect matching in general graph
 
 \image html bipartite_matching.png
Index: lemon/bin_heap.h
===================================================================
--- lemon/bin_heap.h	(revision 2547)
+++ lemon/bin_heap.h	(revision 2548)
@@ -53,8 +53,13 @@
 
   public:
+    ///\e
     typedef _ItemIntMap ItemIntMap;
+    ///\e
     typedef _Prio Prio;
+    ///\e
     typedef typename ItemIntMap::Key Item;
+    ///\e
     typedef std::pair<Item,Prio> Pair;
+    ///\e
     typedef _Compare Compare;
 
@@ -322,4 +327,17 @@
     }
 
+    /// \brief Replaces an item in the heap.
+    ///
+    /// The \c i item is replaced with \c j item. The \c i item should
+    /// be in the heap, while the \c j should be out of the heap. The
+    /// \c i item will out of the heap and \c j will be in the heap
+    /// with the same prioriority as prevoiusly the \c i item.
+    void replace(const Item& i, const Item& j) {
+      int idx = iim[i];
+      iim.set(i, iim[j]);
+      iim.set(j, idx);
+      data[idx].first = j;
+    }
+
   }; // class BinHeap
   
Index: lemon/max_matching.h
===================================================================
--- lemon/max_matching.h	(revision 2505)
+++ lemon/max_matching.h	(revision 2548)
@@ -20,8 +20,12 @@
 #define LEMON_MAX_MATCHING_H
 
+#include <vector>
 #include <queue>
+#include <set>
+
 #include <lemon/bits/invalid.h>
 #include <lemon/unionfind.h>
 #include <lemon/graph_utils.h>
+#include <lemon/bin_heap.h>
 
 ///\ingroup matching
@@ -32,5 +36,5 @@
 
   ///\ingroup matching
-
+  ///
   ///\brief Edmonds' alternating forest maximum matching algorithm.
   ///
